// Code generated by BobGen psql v0.22.0. DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package bob

import (
	"context"

	"github.com/aarondl/opt/omit"
	"github.com/google/uuid"
	"github.com/stephenafamo/bob"
	"github.com/stephenafamo/bob/dialect/psql"
	"github.com/stephenafamo/bob/dialect/psql/dialect"
	"github.com/stephenafamo/bob/dialect/psql/im"
	"github.com/stephenafamo/bob/dialect/psql/sm"
	"github.com/stephenafamo/bob/dialect/psql/um"
)

// User is an object representing the database table.
type User struct {
	UserID       uuid.UUID `db:"user_id,pk" `
	Username     string    `db:"username" `
	Passwordhash string    `db:"passwordhash" `
}

// UserSlice is an alias for a slice of pointers to User.
// This should almost always be used instead of []*User.
type UserSlice []*User

// Users contains methods to work with the users table
var Users = psql.NewTablex[*User, UserSlice, *UserSetter]("", "users")

// UsersQuery is a query on the users table
type UsersQuery = *psql.ViewQuery[*User, UserSlice]

// UsersStmt is a prepared statment on users
type UsersStmt = bob.QueryStmt[*User, UserSlice]

// UserSetter is used for insert/upsert/update operations
// All values are optional, and do not have to be set
// Generated columns are not included
type UserSetter struct {
	UserID       omit.Val[uuid.UUID] `db:"user_id,pk"`
	Username     omit.Val[string]    `db:"username"`
	Passwordhash omit.Val[string]    `db:"passwordhash"`
}

func (s UserSetter) SetColumns() []string {
	vals := make([]string, 0, 3)
	if !s.UserID.IsUnset() {
		vals = append(vals, "user_id")
	}

	if !s.Username.IsUnset() {
		vals = append(vals, "username")
	}

	if !s.Passwordhash.IsUnset() {
		vals = append(vals, "passwordhash")
	}

	return vals
}

func (s UserSetter) Overwrite(t *User) {
	if !s.UserID.IsUnset() {
		t.UserID, _ = s.UserID.Get()
	}
	if !s.Username.IsUnset() {
		t.Username, _ = s.Username.Get()
	}
	if !s.Passwordhash.IsUnset() {
		t.Passwordhash, _ = s.Passwordhash.Get()
	}
}

func (s UserSetter) Apply(q *dialect.UpdateQuery) {
	if !s.UserID.IsUnset() {
		um.Set("user_id").ToArg(s.UserID).Apply(q)
	}
	if !s.Username.IsUnset() {
		um.Set("username").ToArg(s.Username).Apply(q)
	}
	if !s.Passwordhash.IsUnset() {
		um.Set("passwordhash").ToArg(s.Passwordhash).Apply(q)
	}
}

func (s UserSetter) Insert() bob.Mod[*dialect.InsertQuery] {
	vals := make([]bob.Expression, 3)
	if s.UserID.IsUnset() {
		vals[0] = psql.Raw("DEFAULT")
	} else {
		vals[0] = psql.Arg(s.UserID)
	}

	if s.Username.IsUnset() {
		vals[1] = psql.Raw("DEFAULT")
	} else {
		vals[1] = psql.Arg(s.Username)
	}

	if s.Passwordhash.IsUnset() {
		vals[2] = psql.Raw("DEFAULT")
	} else {
		vals[2] = psql.Arg(s.Passwordhash)
	}

	return im.Values(vals...)
}

type userColumnNames struct {
	UserID       string
	Username     string
	Passwordhash string
}

var UserColumns = struct {
	UserID       psql.Expression
	Username     psql.Expression
	Passwordhash psql.Expression
}{
	UserID:       psql.Quote("users", "user_id"),
	Username:     psql.Quote("users", "username"),
	Passwordhash: psql.Quote("users", "passwordhash"),
}

type userWhere[Q psql.Filterable] struct {
	UserID       psql.WhereMod[Q, uuid.UUID]
	Username     psql.WhereMod[Q, string]
	Passwordhash psql.WhereMod[Q, string]
}

func UserWhere[Q psql.Filterable]() userWhere[Q] {
	return userWhere[Q]{
		UserID:       psql.Where[Q, uuid.UUID](UserColumns.UserID),
		Username:     psql.Where[Q, string](UserColumns.Username),
		Passwordhash: psql.Where[Q, string](UserColumns.Passwordhash),
	}
}

// FindUser retrieves a single record by primary key
// If cols is empty Find will return all columns.
func FindUser(ctx context.Context, exec bob.Executor, UserIDPK uuid.UUID, cols ...string) (*User, error) {
	if len(cols) == 0 {
		return Users.Query(
			ctx, exec,
			SelectWhere.Users.UserID.EQ(UserIDPK),
		).One()
	}

	return Users.Query(
		ctx, exec,
		SelectWhere.Users.UserID.EQ(UserIDPK),
		sm.Columns(Users.Columns().Only(cols...)),
	).One()
}

// UserExists checks the presence of a single record by primary key
func UserExists(ctx context.Context, exec bob.Executor, UserIDPK uuid.UUID) (bool, error) {
	return Users.Query(
		ctx, exec,
		SelectWhere.Users.UserID.EQ(UserIDPK),
	).Exists()
}

// PrimaryKeyVals returns the primary key values of the User
func (o *User) PrimaryKeyVals() bob.Expression {
	return psql.Arg(o.UserID)
}

// Update uses an executor to update the User
func (o *User) Update(ctx context.Context, exec bob.Executor, s *UserSetter) error {
	return Users.Update(ctx, exec, s, o)
}

// Delete deletes a single User record with an executor
func (o *User) Delete(ctx context.Context, exec bob.Executor) error {
	return Users.Delete(ctx, exec, o)
}

// Reload refreshes the User using the executor
func (o *User) Reload(ctx context.Context, exec bob.Executor) error {
	o2, err := Users.Query(
		ctx, exec,
		SelectWhere.Users.UserID.EQ(o.UserID),
	).One()
	if err != nil {
		return err
	}

	*o = *o2

	return nil
}

func (o UserSlice) UpdateAll(ctx context.Context, exec bob.Executor, vals UserSetter) error {
	return Users.Update(ctx, exec, &vals, o...)
}

func (o UserSlice) DeleteAll(ctx context.Context, exec bob.Executor) error {
	return Users.Delete(ctx, exec, o...)
}

func (o UserSlice) ReloadAll(ctx context.Context, exec bob.Executor) error {
	var mods []bob.Mod[*dialect.SelectQuery]

	UserIDPK := make([]uuid.UUID, len(o))

	for i, o := range o {
		UserIDPK[i] = o.UserID
	}

	mods = append(mods,
		SelectWhere.Users.UserID.In(UserIDPK...),
	)

	o2, err := Users.Query(ctx, exec, mods...).All()
	if err != nil {
		return err
	}

	for _, old := range o {
		for _, new := range o2 {
			if new.UserID != old.UserID {
				continue
			}

			*old = *new
			break
		}
	}

	return nil
}
